# Communication _search

`POST /Communication/_search`

This resource contains a message, notification, or alert sent to or from patients or other parties. Each communication includes the content, sender, recipient, status, and date information.

You can review or retrieve communications with FHIR passthrough. 

> **Supported fields and schema examples**
>
> We support any valid FHIR field. However, we only display fields we’ve defined in our schema, which are usually based on what’s included in the U.S. Core profile. We recommend relying on U.S. Core requirements. 
>
> Our schema examples show the shape and possibility of each FHIR resource; they aren’t code for real-time API calls. We don’t currently recommend copying and pasting these schema examples for your API calls. [Consider reviewing FHIR API actions](/fhir-api-actions) for realistic examples for particular use cases.

### \_search

Query for communications about a specific patient. 

> **Flexible FHIR queries, different query parameters**
>
> FHIR queries are a flexible option with parameters to refine your search. The response returns a bundle of resources, known as a `searchset` bundle type. [Learn about bundles and bundle types](https://docs.redoxengine.com/permalink/23Q1Oku3NdxxvwYnQGJVrg) in our FHIR glossary.
>
> We add a `required` label only to query parameters _a FHIR server requires if you query it directly_. Remember that Redox <u>**data on demand**</u> isn’t a FHIR server, and your connection may not be either.
>
> _Query parameters vary between sites._ Work with your connection to find out which query parameters they require for a successful search.

## Request body

| Field | Type | Required | Description |
| --- | --- | --- | --- |
| `patient` | Array of string | No | Focus of message (the patient). |
| `patient.identifier` | Array of string | No | One or more external identifiers for the patient |
| `identifier` | Array of string | No | Unique identifier |
| `category` | Array of string | No | Message category |
| `status` | Array of string | No | preparation \| in-progress \| not-done \| on-hold \| stopped \| completed \| entered-in-error \| unknown |
| `encounter` | Array of string | No | Encounter created as part of |
| `encounter.identifier` | Array of string | No | Identifier(s) by which this encounter is known |
| `received` | Array of string | No | When received |

## Request example

_Generated from the schema: the values are placeholders, not a real payload._

```bash
curl 'https://api.redoxengine.com/fhir/R4/{destinationSlug}/{environmentFlag}/Communication/_search' \
--request POST \
--header 'Authorization: Bearer $API_TOKEN' \
--header 'Content-Type: application/x-www-form-urlencoded' \
--data-urlencode 'patient=string' \
--data-urlencode 'patient.identifier=string' \
--data-urlencode 'identifier=string' \
--data-urlencode 'category=string' \
--data-urlencode 'status=string' \
--data-urlencode 'encounter=string' \
--data-urlencode 'encounter.identifier=string' \
--data-urlencode 'received=string'
```

## Responses

### 200

Search results (Bundle)

Response to a Communication search operation

| Field | Type | Required | Description |
| --- | --- | --- | --- |
| `resourceType` | string | Yes | Identifies the type of the resource. Value: Bundle |
| `type` | string | Yes | Identifies this bundle as a response to a search. Value: searchset |
| `total` | number | Yes | The total number of matches |
| `entry` | Array of Communication or Other | No | A resource matching the search criteria or related to a matching resource |
| `entry[] (Communication).resource` | object | Yes | A clinical or administrative communication regarding a patient. |
| `entry[] (Communication).resource.resourceType` | string | Yes | Identifies the type of the resource. Value: Communication |
| `entry[] (Communication).resource.status` | string | Yes | The status of the transmission. Possible values: preparation, in-progress, not-done, on-hold, stopped, completed, entered-in-error, unknown |
| `entry[] (Communication).resource.id` | string | No | The logical id of the resource, as used in the URL for the resource. Once assigned, this value never changes. |
| `entry[] (Communication).resource.identifier` | Array of object | No | Business identifiers assigned to this communication by the performer or other systems which remain constant as the resource is updated and propagates from server to server. |
| `entry[] (Communication).resource.identifier[].extension` | Array of Boolean or String or CodeableConcept or Coding or HumanName or Reference | No | May be used to represent additional information that is not part of the basic definition of the element. To make the use of extensions safe and manageable, there is a strict set of governance  applied to the definition and use of extensions. Though any implementer can define an extension, there is a set of requirements that SHALL be met as part of the definition of the extension. |
| `entry[] (Communication).resource.identifier[].extension[] (Boolean).url` | string | Yes | Source of the definition for the extension code - a logical name or a URL. |
| `entry[] (Communication).resource.identifier[].extension[] (Boolean).valueBoolean` | boolean | No | A single value for the extension. |
| `entry[] (Communication).resource.identifier[].extension[] (String).url` | string | Yes | Source of the definition for the extension code - a logical name or a URL. |
| `entry[] (Communication).resource.identifier[].extension[] (String).valueString` | string | No | A single value for the extension. |
| `entry[] (Communication).resource.identifier[].extension[] (CodeableConcept).url` | string | Yes | Source of the definition for the extension code - a logical name or a URL. |
| `entry[] (Communication).resource.identifier[].extension[] (CodeableConcept).valueCodeableConcept` | object | No | A single value for the extension. |
| `entry[] (Communication).resource.identifier[].extension[] (CodeableConcept).valueCodeableConcept.coding` | Array of object | No | A reference to a code defined by a terminology system. |
| `entry[] (Communication).resource.identifier[].extension[] (CodeableConcept).valueCodeableConcept.coding[].system` | string | No | The identification of the code system that defines the meaning of the symbol in the code. |
| `entry[] (Communication).resource.identifier[].extension[] (CodeableConcept).valueCodeableConcept.coding[].code` | string | No | A symbol in syntax defined by the system. The symbol may be a predefined code or an expression in a syntax defined by the coding system (e.g. post-coordination). |
| `entry[] (Communication).resource.identifier[].extension[] (CodeableConcept).valueCodeableConcept.text` | string | No | A human language representation of the concept as seen/selected/uttered by the user who entered the data and/or which represents the intended meaning of the user. |
| `entry[] (Communication).resource.identifier[].extension[] (Coding).url` | string | Yes | Source of the definition for the extension code - a logical name or a URL. |
| `entry[] (Communication).resource.identifier[].extension[] (Coding).valueCoding` | object | No | A single value for the extension. |
| `entry[] (Communication).resource.identifier[].extension[] (Coding).valueCoding.system` | string | No | The identification of the code system that defines the meaning of the symbol in the code. |
| `entry[] (Communication).resource.identifier[].extension[] (Coding).valueCoding.code` | string | No | A symbol in syntax defined by the system. The symbol may be a predefined code or an expression in a syntax defined by the coding system (e.g. post-coordination). |
| `entry[] (Communication).resource.identifier[].extension[] (HumanName).url` | string | Yes | Source of the definition for the extension code - a logical name or a URL. |
| `entry[] (Communication).resource.identifier[].extension[] (HumanName).valueHumanName` | object | No | A single value for the extension. |
| `entry[] (Communication).resource.identifier[].extension[] (HumanName).valueHumanName.use` | string | No | Identifies the purpose for this name. Possible values: usual, official, temp, nickname, anonymous, old, maiden |
| `entry[] (Communication).resource.identifier[].extension[] (HumanName).valueHumanName.family` | string | No | The part of a name that links to the genealogy. In some cultures (e.g. Eritrea) the family name of a son is the first name of his father. |
| `entry[] (Communication).resource.identifier[].extension[] (HumanName).valueHumanName.given` | Array of string | No | Given name. |
| `entry[] (Communication).resource.identifier[].extension[] (Reference).url` | string | Yes | Source of the definition for the extension code - a logical name or a URL. |
| `entry[] (Communication).resource.identifier[].extension[] (Reference).valueReference` | object | No | A single value for the extension. |
| `entry[] (Communication).resource.identifier[].extension[] (Reference).valueReference.reference` | string | No | A reference to another resource. This is typically either a relative reference which includes the resource type and ID, or an internal reference which starts with `#` and refers to a contained resource. |
| `entry[] (Communication).resource.identifier[].use` | string | No | The purpose of this identifier. Possible values: usual, official, temp, secondary, old (If known) |
| `entry[] (Communication).resource.identifier[].system` | string | No | Establishes the namespace for the value - that is, a URL that describes a set values that are unique. |
| `entry[] (Communication).resource.identifier[].value` | string | No | The portion of the identifier typically relevant to the user and which is unique within the context of the system. |
| `entry[] (Communication).resource.category` | Array of object | No | The type of message conveyed such as alert, notification, reminder, instruction, etc. |
| `entry[] (Communication).resource.category[].coding` | Array of object | No | A reference to a code defined by a terminology system. |
| `entry[] (Communication).resource.category[].coding[].system` | string | No | The identification of the code system that defines the meaning of the symbol in the code. |
| `entry[] (Communication).resource.category[].coding[].code` | string | No | A symbol in syntax defined by the system. The symbol may be a predefined code or an expression in a syntax defined by the coding system (e.g. post-coordination). |
| `entry[] (Communication).resource.category[].text` | string | No | A human language representation of the concept as seen/selected/uttered by the user who entered the data and/or which represents the intended meaning of the user. |
| `entry[] (Communication).resource.subject` | object | No | The patient or group that was the focus of this communication. Must be a resource of type `Patient`. |
| `entry[] (Communication).resource.subject.reference` | string | No | A reference to another resource. This is typically either a relative reference which includes the resource type and ID, or an internal reference which starts with `#` and refers to a contained resource. |
| `entry[] (Communication).resource.topic` | object | No | Description of the purpose/content, similar to a subject line in an email. |
| `entry[] (Communication).resource.topic.coding` | Array of object | No | A reference to a code defined by a terminology system. |
| `entry[] (Communication).resource.topic.coding[].system` | string | No | The identification of the code system that defines the meaning of the symbol in the code. |
| `entry[] (Communication).resource.topic.coding[].code` | string | No | A symbol in syntax defined by the system. The symbol may be a predefined code or an expression in a syntax defined by the coding system (e.g. post-coordination). |
| `entry[] (Communication).resource.topic.text` | string | No | A human language representation of the concept as seen/selected/uttered by the user who entered the data and/or which represents the intended meaning of the user. |
| `entry[] (Communication).resource.encounter` | object | No | The Encounter during which this Communication was created or to which the creation of this record is tightly associated. Must be a resource of type `Encounter`. |
| `entry[] (Communication).resource.encounter.reference` | string | No | A reference to another resource. This is typically either a relative reference which includes the resource type and ID, or an internal reference which starts with `#` and refers to a contained resource. |
| `entry[] (Communication).resource.sent` | string | No | The time when this communication was sent. |
| `entry[] (Communication).resource.received` | string | No | The time when this communication arrived at the destination. |
| `entry[] (Communication).resource.recipient` | Array of object | No | The entity (e.g. person, organization, clinical information system, care team or device) which was the target of the communication. If receipts need to be tracked by an individual, a separate resource instance will need to be created for each recipient.  Multiple recipient communications are intended where either receipts are not tracked (e.g. a mass mail-out) or a receipt is captured in aggregate (all emails confirmed received by a particular time). Must reference one of the following types of resources: - `Device` - `Organization` - `Patient` - `Practitioner` - `PractitionerRole` - `RelatedPerson` - `Group` - `CareTeam` - `HealthcareService` |
| `entry[] (Communication).resource.recipient[].reference` | string | No | A reference to another resource. This is typically either a relative reference which includes the resource type and ID, or an internal reference which starts with `#` and refers to a contained resource. |
| `entry[] (Communication).resource.sender` | object | No | The entity (e.g. person, organization, clinical information system, or device) which was the source of the communication. Must reference one of the following types of resources: - `Device` - `Organization` - `Patient` - `Practitioner` - `PractitionerRole` - `RelatedPerson` - `HealthcareService` |
| `entry[] (Communication).resource.sender.reference` | string | No | A reference to another resource. This is typically either a relative reference which includes the resource type and ID, or an internal reference which starts with `#` and refers to a contained resource. |
| `entry[] (Communication).resource.payload` | Array of object | No | Text, attachment(s), or resource(s) that was communicated to the recipient. |
| `entry[] (Communication).resource.payload[].contentString` | string | Yes | A communicated content (or for multi-part communications, one portion of the communication). Only one of `contentString`, `contentAttachment` may be present. |
| `entry[] (Communication).resource.payload[].contentAttachment` | object | Yes | A communicated content (or for multi-part communications, one portion of the communication). Only one of `contentString`, `contentAttachment` may be present. |
| `entry[] (Communication).resource.payload[].contentAttachment.contentType` | string | No | Identifies the type of the data in the attachment and allows a method to be chosen to interpret or render the data. Includes mime type parameters such as charset where appropriate. |
| `entry[] (Communication).resource.payload[].contentAttachment.data` | string | No | The actual data of the attachment - a sequence of bytes, base64 encoded. |
| `entry[] (Communication).resource.payload[].contentAttachment.creation` | string | No | The date that the attachment was first created. |
| `entry[] (Communication).search` | object | Yes | Information about the search process that lead to the creation of this entry. |
| `entry[] (Communication).search.mode` | string | Yes | Identifies the Communication as matching the search parameters. Value: match |
| `entry[] (Other).search` | object | Yes | Information about the search process that lead to the creation of this entry. |
| `entry[] (Other).search.mode` | string | No | Why this entry is in the result set - whether it's included as a match or because of an _include requirement, or to convey information or warning information about the search process. Possible values: match, include, outcome - why this is in the result set |

_Generated from the schema: the values are placeholders, not a real payload._

```json
{
  "resourceType": "Bundle",
  "type": "searchset",
  "total": 0,
  "entry": [
    {
      "resource": {
        "resourceType": "Communication",
        "id": "RedoxCommunicationExample",
        "status": "completed",
        "category": [
          {
            "coding": [
              {
                "code": "instruction",
                "system": "http://terminology.hl7.org/CodeSystem/communication-category"
              }
            ],
            "text": "instruction"
          }
        ],
        "subject": {
          "reference": "Patient/RedoxPatientExampleTimothy"
        },
        "topic": {
          "coding": [
            {
              "code": "311401005",
              "system": "http://snomed.info/sct"
            }
          ],
          "text": "Patient Education"
        },
        "encounter": {
          "reference": "Encounter/RedoxEncounterExample"
        },
        "recipient": [
          {
            "reference": "Patient/RedoxPatientExampleTimothy"
          }
        ],
        "sender": {
          "reference": "Practitioner/RedoxPractitionerExamplePat"
        },
        "payload": [
          {
            "contentAttachment": {
              "data": "PGRpdiB4bWxucz0iaHR0cDovL3d3dy53My5vcmcvMTk5OS94aHRtbCI+UGxlYXNlIGNhcmVmdWxseSBmb2xsb3cgdGhlIHN1YnNlcXVlbnQgaW5zdHJ1Y3Rpb25zIGFuZCBwYXRpZW50IGVkdWNhdGlvbjo8YnI+PC9icj48YnI+PC9icj48dWw+PGxpPkZsb3NzPC9saT48bGk+QnJ1c2ggdGVldGggdHdpY2UgZGFpbHk8L2xpPjwvdWw+PGJyPjwvYnI+PGJyPjwvYnI+U2NhcmYgdHlpbmcgaW5zdHJ1Y3Rpb25zIG1heSBiZSBmb3VuZCBvbmxpbmUuPC9kaXY+Cg==",
              "contentType": "application/xhtml+xml",
              "creation": "2021-12-17T20:33:22.422Z"
            }
          }
        ]
      },
      "search": {
        "mode": "match"
      }
    }
  ]
}
```

### 400

Request could not be processed or failed validation

| Field | Type | Required | Description |
| --- | --- | --- | --- |
| `resourceType` | string | Yes | Identifies the type of the resource. Value: OperationOutcome |
| `issue` | Array of object | Yes | A structured respresentation of the error that occurred |
| `issue[].severity` | string | Yes | Generally `error` or `fatal` Possible values: fatal, error, warning, information |
| `issue[].code` | string | Yes | A FHIR category code that describes the general type of issue. See http://hl7.org/fhir/ValueSet/issue-type for details |
| `issue[].id` | string | No | If the error occurs in the RedoxEngine, this corresponds to an Error record in the organization. |
| `issue[].details` | object | No | Additional details about the error. This may be a text description of the error or a system code that identifies the error. |
| `issue[].details.coding` | Array of object | No | A more granular FHIR code for the specific error. Typically from http://hl7.org/fhir/ValueSet/operation-outcome |
| `issue[].details.coding[].system` | string | No | The identification of the code system that defines the meaning of the symbol in the code. |
| `issue[].details.coding[].code` | string | No | A symbol in syntax defined by the system. The symbol may be a predefined code or an expression in a syntax defined by the coding system (e.g. post-coordination). |
| `issue[].details.text` | string | No | A human-readable interpretation of the issue code |
| `issue[].diagnostics` | string | No | Additional diagnostic information about the issue. |

```json
{
  "resourceType": "OperationOutcome",
  "issue": [
    {
      "severity": "fatal",
      "code": "invalid",
      "details": {
        "coding": [
          {
            "code": "MSG_BAD_SYNTAX",
            "system": "http://terminology.hl7.org/CodeSystem/operation-outcome"
          }
        ],
        "text": "Invalid content found in request body."
      }
    }
  ]
}
```

### 401

Authorization is required

Same fields as 400.

```json
{
  "resourceType": "OperationOutcome",
  "issue": [
    {
      "severity": "fatal",
      "code": "unknown",
      "details": {
        "coding": [
          {
            "code": "MSG_AUTH_REQUIRED",
            "system": "http://terminology.hl7.org/CodeSystem/operation-outcome"
          }
        ],
        "text": "Invalid authorization token"
      }
    }
  ]
}
```

### 500

Internal server error

Same fields as 400.

```json
{
  "resourceType": "OperationOutcome",
  "issue": [
    {
      "severity": "fatal",
      "code": "processing",
      "details": {
        "coding": [
          {
            "code": "MSG_RESOURCE_ID_FAIL",
            "system": "http://terminology.hl7.org/CodeSystem/operation-outcome"
          }
        ],
        "text": "Unable to allocate resource id."
      }
    }
  ]
}
```

### 503

Service unavailable

Same fields as 400.

```json
{
  "resourceType": "OperationOutcome",
  "issue": [
    {
      "severity": "fatal",
      "code": "transient",
      "details": {
        "text": "System is unable to process this message at this time."
      }
    }
  ]
}
```
